﻿package communication{


	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.*;
	import flash.text.TextField;

	// communication classes
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	import flash.net.SharedObject;
	import flash.external.ExternalInterface;
	import flash.net.FileReference;
	import flash.net.FileFilter;
	import fl.controls.ProgressBarMode;
	import flash.utils.Timer;

	public class Communication extends MovieClip {

		// this code does not include URLVariables for connection with a server
		// nor XML, Sockets, Web Services, Remoting or Flash Media Server
		// these ways of communicating will be addressed in other files

		// below are the types of communication that are included
		// along with the basic functionality of each

		public function Communication() {

			// to go to another Web page or call JavaScript
			doNavigateToURL();

			// to store information on the client's computer like a cookie
			doSharedLocalObject();

			// to receive variables from the Flash object or embed tags or query call
			// it is easier these days to use FlashVars rather than a query call
			// a query call is like myfile.swf?id=12345
			doFlashVars();

			// here is how to set up a flash function that gets called by JavaScript
			// note that external interface was not working in IE if you called it right away			
			var myTimer:Timer = new Timer(1000, 1);
			myTimer.start();
			myTimer.addEventListener(TimerEvent.TIMER, doExternalInterface);

			// here is how to load swf file - you can use the Loader class too
			// but the UILoader component has automatic scaling (that sort of works)
			doLoadSWF();

			// here is how you upload a file from the client to the server then show it
			doFileReference();

		}
		// -------------  NavigateToURL  -------------------

		private function doNavigateToURL() {
			myButton1.addEventListener(MouseEvent.CLICK, doURL);
			myButton2.addEventListener(MouseEvent.CLICK, doJavaScript);
		}
		private function doURL(e:MouseEvent) {
			// loads a Web page - use a target of "_self" to open in own window
			navigateToURL(new URLRequest("http://danzen.wordpress.com"), "danzen");
		}
		private function doJavaScript(e:MouseEvent) {
			// you can call a JavaScript function on your page to pop a window, or make an AJAX call, etc.
			navigateToURL(new URLRequest("javascript:alert('hello');"), "_self");
		}
		// -------------  SharedObject  -------------------

		private var mySO:SharedObject;
		private function doSharedLocalObject() {
			mySO = SharedObject.getLocal("test");
			if (!mySO.data.id) {
				mySO.data.id = Math.floor(Math.random()*1000000);
				mySO.data.total = 0;
			}
			mySOText.text = mySO.data.id;
			mySetVariables.text = mySO.data.total;
		}
		// -------------  FlashVars  -------------------

		private function doFlashVars() {
			myURL.text = String(loaderInfo.parameters.myURL);
			myTitle.text = String(loaderInfo.parameters.myTitle);
		}
		// -------------  ExternalInterface  -------------------

		private function doExternalInterface(e:TimerEvent) {
			// use this instead of the old way - setVariable() in JavaScript
			// the first parameter is the Flash function that will be called from JavaScript
			// and the second parameter is the function in JavaScript that does the calling
			// these should not be the same name!
			ExternalInterface.addCallback("toActionScript", fromJavaScript);
		}
		
		public function fromJavaScript(myMessage:String) {
			mySetVariables.text = String(Number(mySetVariables.text) + 1);
			mySO.data.total++;// keeping track with a shared object just for fun ;-)
			mySO.flush();// immediately write the shared object rather than waiting for file close
		}
		// -------------  Load SWF  -------------------
		private function doLoadSWF() {
			myLoader.load(new URLRequest("test.swf"));
			myLoader.scaleContent = true;
			myLoader.addEventListener(Event.COMPLETE, loadComplete);
		}
		private function loadComplete(e:Event) {
			myProgress.alpha = 0;
		}
		// -------------  FileReference  -------------------

		private var myFile:FileReference;
		private var dir:String;
		private function doFileReference() {
			dir = "http://www.yourserver.com/files/";
			myFile = new FileReference();
			myFile.addEventListener(Event.SELECT, selectHandler);
			myFile.addEventListener(Event.COMPLETE, completeHandler);
			myButton3.addEventListener(MouseEvent.CLICK, browseFile);
		}
		private function browseFile(e:Event):void {
			myFile.browse([new FileFilter("Images (*.jpg, *.jpeg, *.gif, *.png)", "*.jpg;*.jpeg;*.gif;*.png")]);
		}
		private function completeHandler(e:Event):void {
			myLoader.load(new URLRequest(dir + e.target.name));
			myProgress.myText.text = "downloading";
			myProgress.mode = ProgressBarMode.EVENT;
			myProgress.myProgressBar.reset();
			myProgress.myProgressBar.source = myLoader;
		}
		private function selectHandler(e:Event):void {
			myFile.upload(new URLRequest(dir + "files.php"));
			myProgress.myText.text = "uploading";
			myProgress.alpha = 1;
			myProgress.mode = ProgressBarMode.EVENT;
			myProgress.myProgressBar.reset();
			myProgress.myProgressBar.source = myFile;
		}
	}
}